<?php
namespace Ems\portalGestor\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\{ Message, Error };
use Zeedhi\Framework\DataSource\DataSet;

use Ems\portalGestor\Service\ParceiroNegocioService;
use Ems\portalGestor\Util\ExpectedException;

class ParceiroNegocioController {
    /** @var ParceiroNegocioService */
    protected $parceiroNegocioService;

    public function __construct(
        ParceiroNegocioService $parceiroNegocioService
    ) {
      $this->parceiroNegocioService = $parceiroNegocioService;
    }

    public function getParcNegocioTodos(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();

            $dataSet = $this->parceiroNegocioService->getParcNegocioTodos(
                $row
            );

            $response->addDataSet(new DataSet('data', $dataSet));
        } catch (ExpectedException $e) {
            $response->addMessage(new Message($e->getMessage(), Message::TYPE_ERROR));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}