<?php
namespace Ems\portalGestor\Service;

use Ems\portalGestor\Util\HcmServices;
use Ems\portalGestor\Service\{ ParamOrgService };

class IntervaloService {

    /** @var HcmServices */
    protected $hcmServices;

    /** @var ParamOrgService */
    protected $paramOrgService;

    public function __construct(
        HcmServices $hcmServices,
        ParamOrgService $paramOrgService
    ) {
        $this->hcmServices = $hcmServices;
        $this->paramOrgService = $paramOrgService;
    }

    public function insertIntervalo(
        int    $nrOrg,
        int    $nrVinculo,
        string $date,
        string $time,
        bool   $before,
        array  $ocorrenciaRow
    ): array {
        $hcmServicesRoute = 'insertIntervalo';

        $nrColetorGestor = $this->paramOrgService->getNrColetorGestor($nrOrg);

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRVINCULOM'     => $nrVinculo,
                'DATE'           => $date,
                'HORARIO_INICIO' => $time,
                'BEFORE'         => $before,
                'ocorrencia'     => $ocorrenciaRow,
                'NRCOLETOR'      => $nrColetorGestor,
            ],
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $status = (array) $response['dataset'][$hcmServicesRoute];

        return $status;
    }

    public function deleteIntervalo(
        int    $nrOrg,
        int    $nrVinculo,
        string $date,
        string $hrInicio,
        string $hrFim,
        bool   $before
    ): array {
        $hcmServicesRoute = 'deleteIntervalo';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRVINCULOM'    => $nrVinculo,
                'DATE'          => $date,
                'DTHRINICIO'    => $hrInicio,
                'DTHRFIM'       => $hrFim,
                'before'        => $before,
            ],
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $status = (array) $response['dataset'][$hcmServicesRoute];

        return $status;
    }
}
